<template>
  <div class="wrapper">
    <h1 class="title">Données récupérées par les capteurs</h1>
    <font-awesome-icon
      @click="deleteAllSensorsFromApi"
      icon="fa-solid fa-trash-can"
      style="font-size: 2rem"
      class="delete-all" />
    <div class="humidity">
      <LineChart label="Humidity" :labels="labels" background-color="#a0f4ff" :data="humidity" />
    </div>
    <div class="temperature">
      <LineChart
        label="Temperature"
        :labels="labels"
        background-color="#ec9f5f"
        :data="temperature" />
    </div>
    <div class="luminosity">
      <LineChart
        label="Luminosity"
        :labels="labels"
        background-color="#ecee61"
        :data="luminosity" />
    </div>
    <div class="motions">
      <font-awesome-icon
        v-if="getLastMotion() === 'detected'"
        icon="fa-solid fa-person-running"
        style="font-size: 7rem" />
      <font-awesome-icon v-else icon="fa-solid fa-person" style="font-size: 7rem" />
      <h3 style="text-align: center">{{ getLastMotion() }}</h3>
    </div>
    <div class="intrusions">
      <font-awesome-icon
        v-if="getLastIntrusion() === 'opened'"
        icon="fa-solid fa-door-open"
        style="font-size: 7rem" />
      <font-awesome-icon v-else icon="fa-solid fa-door-closed" style="font-size: 7rem" />
      <h3 style="text-align: center">{{ getLastIntrusion() }}</h3>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from "vue";
import { getSensorsDataFromApi, deleteAllSensorsDataFromApi } from "./services/sensorsData/api";
import type { SensorsData } from "./services/sensorsData/types";

import LineChart from "./components/LineChart/LineChart.vue";
import type { AxiosResponse } from "axios";

const sensorsData = ref<SensorsData[]>([]);

const humidity = ref<number[]>([]);
const temperature = ref<number[]>([]);
const luminosity = ref<number[]>([]);

const motions = ref<string[]>([]);
const intrusions = ref<string[]>([]);

const labels = ref<string[]>(["0"]);

let numberOfData: number = 0;

/**
 * Met à jour les valeurs des labels en fonction des données récupérées via l'api
 * @param numberOfData nombre de données récupérées à afficher dans le graphique
 */
function updateLabelsValues(numberOfData: number): string[] {
  const labels: string[] = [];
  let secondCounter: number = 0;
  for (let i = 0; i < numberOfData; i++) {
    secondCounter += 3;
    labels.push(secondCounter.toString());
  }
  return labels;
}

/**
 * Met à jour les valeurs des labels
 */
function setLabels(): void {
  numberOfData = humidity.value.length;
  labels.value = updateLabelsValues(numberOfData);
}

/**
 * Extrait les données récupérées via l'api pour les insérer dans les variables vue
 * @param sensorsData données récupérées via l'api
 */
function extractData(sensorsData: SensorsData[]): void {
  humidity.value = sensorsData.map((sensorData) => sensorData.humidity);
  temperature.value = sensorsData.map((sensorData) => sensorData.temperature);
  luminosity.value = sensorsData.map((sensorData) => sensorData.luminosity);
  motions.value = sensorsData.map((sensorData) => sensorData.motions);
  intrusions.value = sensorsData.map((sensorData) => sensorData.intrusions);
}

/**
 * Récupère les données des capteurs via l'api
 */
async function getSensorsData() {
  try {
    const res: AxiosResponse = await getSensorsDataFromApi();
    sensorsData.value = res.data;
    extractData(sensorsData.value);
  } catch (error) {
    console.error(error);
  }
}

/**
 * Supprime toutes les données des capteurs stockées en base de données
 */
async function deleteAllSensorsFromApi() {
  try {
    await deleteAllSensorsDataFromApi();
  } catch (error) {
    console.error(error);
  }
}

/**
 * Retourne la dernière valeur de motions
 */
function getLastMotion(): string {
  return motions.value[motions.value.length - 1];
}

/**
 * Retourne la dernière valeur de intrusions
 */
function getLastIntrusion(): string {
  return intrusions.value[intrusions.value.length - 1];
}

onMounted(() => {
  getSensorsData();
  setLabels();
  setInterval(() => {
    getSensorsData();
    setLabels();
  }, 3000);
});
</script>

<style scoped>
.wrapper {
  padding-inline: 1%;
  display: grid;
  height: 97vh;
  grid-template-columns: repeat(2, 1fr) 5% repeat(2, 1fr);
  grid-template-rows: 15% 30% 30% 15%;
}

.title {
  grid-column: 1 / 6;
  grid-row: 1 / 2;
  text-align: center;
}

.delete-all {
  grid-column: 6 / 7;
  grid-row: 1 / 2;
  text-align: center;
  margin-top: 20%;
  cursor: pointer;
}

.humidity {
  grid-column: 1 / 3;
  grid-row: 2 / 3;
}

.temperature {
  grid-column: 4 / 6;
  grid-row: 2 / 3;
}

.luminosity {
  grid-column: 2 / 5;
  grid-row: 3 / 4;
}

.motions {
  grid-column: 1 / 2;
  grid-row: 4 / 5;
  justify-self: center;
}

.intrusions {
  grid-column: 5 / 6;
  grid-row: 4 / 5;
  justify-self: center;
}
</style>
